For AI agents: A markdown version of this page is available at https://docs.datadoghq.com/api/latest/key-management/get-all-access-tokens.md. A documentation index is available at /llms.txt.

Get all access tokens

GET https://api.ap1.datadoghq.com/api/v2/personal_access_tokenshttps://api.ap2.datadoghq.com/api/v2/personal_access_tokenshttps://api.datadoghq.eu/api/v2/personal_access_tokenshttps://api.ddog-gov.com/api/v2/personal_access_tokenshttps://api.us2.ddog-gov.com/api/v2/personal_access_tokenshttps://api.uk1.datadoghq.com/api/v2/personal_access_tokenshttps://api.datadoghq.com/api/v2/personal_access_tokenshttps://api.us3.datadoghq.com/api/v2/personal_access_tokenshttps://api.us5.datadoghq.com/api/v2/personal_access_tokens

Overview

List all access tokens for the organization. This endpoint requires any of the following permissions:

  • user_app_keys
  • org_app_keys_read

  • Arguments

    Query Strings

    Name

    Type

    Description

    page[size]

    integer

    Number of items to return per page. The maximum allowed value is 100.

    page[number]

    integer

    Specific page number to return.

    sort

    enum

    Access token attribute used to sort results. Sort order is ascending by default. In order to specify a descending sort, prefix the attribute with a minus sign.
    Allowed enum values: name, -name, created_at, -created_at, expires_at, -expires_at, last_used_at, -last_used_at, leaked, -leaked

    filter

    string

    Filter access tokens by the specified string.

    filter[owned_by]

    array

    Filter access tokens by the owner’s ID. Supports multiple values.

    filter[leaked]

    boolean

    When true, only return access tokens that have been detected as leaked. Has no effect when false.

    include

    array

    Comma-separated list of relationship objects that should be included in the response.

    Response

    OK

    Response for a list of access tokens. Includes both personal and service access tokens.

    Expand All

    Field

    Type

    Description

    data

    [object]

    Array of access tokens. Includes both personal and service access tokens.

    attributes

    object

    Attributes of an access token.

    created_at

    date-time

    Creation date of the access token.

    expires_at

    date-time

    Expiration date of the access token.

    last_used_at

    date-time

    Date the access token was last used.

    modified_at

    date-time

    Date of last modification of the access token.

    name

    string

    Name of the access token.

    public_portion

    string

    The public portion of the access token.

    scopes

    [string]

    Array of scopes granted to the access token.

    id

    string

    ID of the access token.

    relationships

    object

    Resources related to the access token entry in the mixed list response.

    leak_information

    object

    Relationship to the leak the access token was found in. data is null when the access token has not been detected as leaked.

    data [required]

    object

    Relationship to the leak the access token was found in.

    id [required]

    string

    A unique identifier that represents the leak.

    type [required]

    enum

    The definition of LeakedKeyType object. Allowed enum values: leaked_keys

    default: leaked_keys

    owned_by

    object

    Relationship to the access token's owner.

    data [required]

    object

    Relationship to the access token's owner.

    id [required]

    string

    A unique identifier that represents the owner.

    type [required]

    enum

    Owner resource type. Either a user or a service account. Allowed enum values: users,service_account

    type

    enum

    Resource type returned by the access tokens list endpoint. Includes both personal and service access tokens. Allowed enum values: personal_access_tokens,service_access_tokens

    included

    [ <oneOf>]

    Array of objects related to the access tokens.

    <type=leaked_keys>

    object

    The definition of LeakedKey object.

    attributes [required]

    object

    The definition of LeakedKeyAttributes object.

    date [required]

    date-time

    The LeakedKeyAttributes date.

    leak_source

    string

    The LeakedKeyAttributes leak_source.

    id [required]

    string

    The LeakedKey id.

    type [required]

    enum

    The definition of LeakedKeyType object. Allowed enum values: leaked_keys

    default: leaked_keys

    meta

    object

    Additional information related to the access token response.

    page

    object

    Pagination information.

    total_filtered_count

    int64

    Total filtered access token count.

    {
      "data": [
        {
          "attributes": {
            "created_at": "2024-01-01T00:00:00+00:00",
            "expires_at": "2025-12-31T23:59:59+00:00",
            "last_used_at": "2025-06-15T12:30:00+00:00",
            "modified_at": "2024-06-01T00:00:00+00:00",
            "name": "My Access Token",
            "public_portion": "ddpat_abc123",
            "scopes": [
              "dashboards_read",
              "dashboards_write"
            ]
          },
          "id": "string",
          "relationships": {
            "leak_information": {
              "data": {
                "id": "00000000-0000-1234-0000-000000000000",
                "type": "leaked_keys"
              }
            },
            "owned_by": {
              "data": {
                "id": "00000000-0000-0000-2345-000000000000",
                "type": "users"
              }
            }
          },
          "type": "personal_access_tokens"
        }
      ],
      "included": [
        {
          "attributes": {
            "date": "2017-07-21T17:32:28Z",
            "leak_source": "string"
          },
          "id": "id",
          "type": "leaked_keys"
        }
      ],
      "meta": {
        "page": {
          "total_filtered_count": "integer"
        }
      }
    }

    Bad Request

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Forbidden

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Too many requests

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Code Example

                      # Use a Personal Access Token or Service Access Token
    export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

    # Curl command
    curl -X GET "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/personal_access_tokens" \ -H "Accept: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}"
    """
    Get all access tokens returns "OK" response
    """
    
    from os import environ
    from datadog_api_client import ApiClient, Configuration
    from datadog_api_client.v2.api.key_management_api import KeyManagementApi
    
    configuration = Configuration()
    configuration.access_token = environ["DD_BEARER_TOKEN"]
    with ApiClient(configuration) as api_client:
        api_instance = KeyManagementApi(api_client)
        response = api_instance.list_personal_access_tokens()
    
        print(response)
    

    Instructions

    First install the library and its dependencies and then save the example to example.py and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
    # Get all access tokens returns "OK" response
    
    require "datadog_api_client"
    DatadogAPIClient.configure do |config|
      config.access_token = ENV["DD_BEARER_TOKEN"]
    end
    api_instance = DatadogAPIClient::V2::KeyManagementAPI.new
    p api_instance.list_personal_access_tokens()
    

    Instructions

    First install the library and its dependencies and then save the example to example.rb and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
    // Get all access tokens returns "OK" response
    
    package main
    
    import (
    	"context"
    	"encoding/json"
    	"fmt"
    	"os"
    
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
    )
    
    func main() {
    	ctx := datadog.NewDefaultContext(context.Background())
    	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
    	configuration := datadog.NewConfiguration()
    	apiClient := datadog.NewAPIClient(configuration)
    	api := datadogV2.NewKeyManagementApi(apiClient)
    	resp, r, err := api.ListPersonalAccessTokens(ctx, *datadogV2.NewListPersonalAccessTokensOptionalParameters())
    
    	if err != nil {
    		fmt.Fprintf(os.Stderr, "Error when calling `KeyManagementApi.ListPersonalAccessTokens`: %v\n", err)
    		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
    	}
    
    	responseContent, _ := json.MarshalIndent(resp, "", "  ")
    	fmt.Fprintf(os.Stdout, "Response from `KeyManagementApi.ListPersonalAccessTokens`:\n%s\n", responseContent)
    }
    

    Instructions

    First install the library and its dependencies and then save the example to main.go and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
    // Get all access tokens returns "OK" response
    
    import com.datadog.api.client.ApiClient;
    import com.datadog.api.client.ApiException;
    import com.datadog.api.client.v2.api.KeyManagementApi;
    import com.datadog.api.client.v2.model.ListPersonalAccessTokensResponse;
    
    public class Example {
      public static void main(String[] args) {
        ApiClient defaultClient = ApiClient.getDefaultApiClient();
        defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
        KeyManagementApi apiInstance = new KeyManagementApi(defaultClient);
    
        try {
          ListPersonalAccessTokensResponse result = apiInstance.listPersonalAccessTokens();
          System.out.println(result);
        } catch (ApiException e) {
          System.err.println("Exception when calling KeyManagementApi#listPersonalAccessTokens");
          System.err.println("Status code: " + e.getCode());
          System.err.println("Reason: " + e.getResponseBody());
          System.err.println("Response headers: " + e.getResponseHeaders());
          e.printStackTrace();
        }
      }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to Example.java and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
    // Get all access tokens returns "OK" response
    use datadog_api_client::datadog;
    use datadog_api_client::datadogV2::api_key_management::KeyManagementAPI;
    use datadog_api_client::datadogV2::api_key_management::ListPersonalAccessTokensOptionalParams;
    
    #[tokio::main]
    async fn main() {
        let configuration = datadog::Configuration::new();
        let api = KeyManagementAPI::with_config(configuration);
        let resp = api
            .list_personal_access_tokens(ListPersonalAccessTokensOptionalParams::default())
            .await;
        if let Ok(value) = resp {
            println!("{:#?}", value);
        } else {
            println!("{:#?}", resp.unwrap_err());
        }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to src/main.rs and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
    /**
     * Get all access tokens returns "OK" response
     */
    
    import { client, v2 } from "@datadog/datadog-api-client";
    
    const configuration = client.createConfiguration({
      authMethods: {
        AuthZ: {
          accessToken: process.env.DD_BEARER_TOKEN as string,
        },
      },
    });
    const apiInstance = new v2.KeyManagementApi(configuration);
    
    apiInstance
      .listPersonalAccessTokens()
      .then((data: v2.ListPersonalAccessTokensResponse) => {
        console.log(
          "API called successfully. Returned data: " + JSON.stringify(data)
        );
      })
      .catch((error: any) => console.error(error));
    

    Instructions

    First install the library and its dependencies and then save the example to example.ts and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"